//NRob03 プログラム作成  新基板　低学年用

//NRob3 プログラム作成
//v356	20210717	JB入力,Bジャンプできないバグ,10行スクロール追加

//v331  20191117  メモリ簡略版テスト
//v024	20201105	音センサ組込み　拍手リモコン追加
//v036	20211008	NRob3基板対応　Vモード追加
//v037	20220218	NRob同一フォルダーに入れる
//v038	20231102	旧バージョン表示タイプとする

//---ポート設定----
//D00   RX
//D01   TX
//D02   TB6612  INA1
//D03   TB6612  INA2
//D04   TB6612  INB1
//D05   TB6612  PWMA
//D06   TB6612  PWMB
//D07   TB6612  INB2
//D08   Servo M3 SIG
//D09   Servo M4 SIG
//D10   Sonar S7 Trig
//D11   Sonar S7 Echo
//D12   Sonar S8 Trig
//D13   Sonar S8 Echo
//A0    AD input S1
//A1    AD input S2
//A2    AD input S3
//A3    AD input S4
//A4    I2C SDA
//A5    I2C SCL
//A6    AD input S5
//A7    AD input S6

//MCP23017
//GPA0  SWS Select
//GPA1  SWD Down
//GPA2  SWU Up
//GPA3  SWR Right
//GPA4  SWL Left
//GPA5  LED3
//GPA6  LED2
//GPA7  LED1
//GPB0  LCD1602 LD7
//GPB1  LCD1602 LD6
//GPB2  LCD1602 LD5
//GPB3  LCD1602 LD4
//GPB4  LCD1602 LE
//GPB5  LCD1602 LRW
//GPB6  LCD1602 LRS
//GPB7  x
//-------------------------------------


/*
*データ構造
  1 階層　正負
    上位4ビット：階層0-4/下位４ビット 各階層の正負(YorN)
  2 コマンド  下表
  3-5 引数  ：　0-99:正整数/100-199：負整数/200-209：S1-9/210-219:C1-9/
              220-229:X1-9/230-239:T1-9/240-249:記号

//コマンド
//01  G motor+wait +00,+00,00(LR+wait)
//02  M motor +00,+00(LR)
//03  V servo no,00
//04  W wait  00
//05  L LED,LCD no,+00        //L4=+50
//元 05  B block 0               //B:1

//10  ? if S  no,kigo,00
//11  ? if C  
//12  ? if X
//13  ? if T
//14  ? if R  rimocom

//20  $ betwen S  no,lo,hi
//21  $ betwen C  no,lo,hi
//22  $ betwen X  no,lo,hi
//23  $ betwen T  no,lo,hi

//32  # set X no,kigo,0orX
//33  # set T no,kigo,0orX
//止め　34  # set Lcd no,Xno
//止め  35  # set B 0

//40  B:  blockNo   例:B:01  /mem:0,40,no,0,0
//41  JB: blockNo   例:JB:01 /mem:X,41,no,0,0
//42  JN: lineNo    例:JN:12 /mem:X,42,no,0,0


//---- テーブル形式---
unsigned char prgMem[MAXLINE][5];
                            // 01234567890123
unsigned char dspPrg[2][14]={{"G+50+50;10    "},
                             {"#B=02         "}};
                        //0   1   2   3   4   5   6   7   8   9
unsigned char SKIGO[]=  {'=','<','>','!','+','-','*','/',' ',' '};
unsigned char VARI[]=   {'S','C','X','T','L','I','O','B',' ',' '};//v350

/* 関数リスト
//*** メイン  ***********************************************
setup:
                    init_MPC23017/LCD_init/init_TB6612/init_PrgData
loop:
    モード切替
    0=chg_Mode_main();        //モード切替動作
    1=do_Action_main();       //プログラム実行動作
    2=do_Setting_main();      //センサーモニタ
    3=
    4=edit_Prg_main();        //エディタ動作

void	timer_Int(void)										//基準時間カウント タイマ割込の代り
void	timer_getSW(void)									//タイマ動作＋SW入力
byte	is_SelSW(void)										//SelSW入力+タイマ動作

chg_Mode_main()               //モード変更動作
                              初期表示
                              Up/Downキー入力でメニュー切替 PAGENUM=4枚
                              selキーで確定

//*** 初期化  ***********************************************
void	init_PrgData(void)								//プログラムデータ初期化

//*** モード変更動作  ***************************************
void	chg_Mode_main(void)								//モード変更動作メイン

//*** 動作  *************************************************
void	do_Action_main(void)							//プログラム実行動作メイン
void	prg_Analyse(void)									//プログラム解析
byte	ctrl_Branch(void)									//条件分岐  ans:1=実行/2=スキップ
void	do_command(void)									//コマンド動作
void	do_MoveCom(void)									//コマンド 動作系
void	do_Go(void)												//Goコマンド モーター＋wait
void	do_Motor(void)										//モーターコマンド
void	do_Servo(void)										//サーボ
void	do_Wait(void)											//Waitコマンド
void	do_IfCom(void)										//? 判定動作
void	do_WithinCom(void)								//$ 範囲判定動作
void	do_SetCom(void)										//# 変数セット命令
void	do_SetX(void)											//# 変数セット命令 X
void	do_SetTim(void)										//# 変数セット命令 T
void	do_LEDLCD(void)										//L LED,LCD操作
void	dsp_L_All(void)										//L変数表示
void	do_JumpCom(void)									//J 動作
void	do_return(void)										//Block終わりでreturn
void	do_jumpB(void)										//Blockジャンプ(サブルーチンジャンプ)
int		seek_Block(byte no)								//Block を探す
void	do_jumpN(void)										//番号へ直接ジャンプ
int		chg_Argument(byte n)							//引数を数字に変換 正負＋変数
void	Timer_Count(void)									//タイマーカウント

//*** AD入力    *********************************************
void	get_AD(void)											//ADを順に取込

//*** プログラム編集  ***************************************
void	edit_Prg_main(void)								//プログラムエディタメイン
void	set_Prg(byte ln)									//プログラム更新　表示->memへ

//*** センサーモニタ   ************************************
void	do_Setting_main(void)							//センサーモニタ動作メイン
void	moni_AD(void)											//AD入力モニタ
void	moni_Sonar(void)									//超音波センサモニタ
void	moni_Compas(void)									//コンパスモニタ
void	moni_Servo(void)									//サーボ動作テスト
void	moni_Serial(void)									//シリアル通信

//*** シリアル通信            ****************************************
void	rcv_Serial()											//シリアル通信受信
void  clear_Srcv()											//シリアルバッファ初期化
void	com_PC()													//PCと通信

//***   prgデータ操作    **********************************************
void	clear_AllLine(void)								//プログラム全行消去
void	setPrg_clrLine(int y, int x)			//プログラム一行消去
void	setPrg_InsLine(byte l)						//プログラム一行挿入
void	setPrg_DelLine(byte l)						//プログラム一行削除
int		setPrg_seekLast(void)							//プログラム最後の行を返す
void	setPrg_cpyLine(int a, int b)			//プログラム一行コピー(b->a)
void	setPrg_Pattern(int pl)						//コマンドの基本パターンセット

//*** コンパス  *********************************************
void	init_GY271(void)									//コンパスモジュール初期化
void	read_Angle(void)									//コンパス読み込み

//*** prgデータ操作　EEPROM    ***************************************
int		chk_ROM(void)											//ROM書き込みあるかチェック
void	init_ROM(void)										//ROM＋prg初期化
void	read_AllROM(void)									//ROM全読み込み
void	write_AllROM(void)								//ROM全　書込み

//-----         */


//#include <VarSpeedServo.h> 
#include <EEPROM.h>
#include "NRob.h"
#include "NRobDispMode.h"
#include "NRobDispPrg.h"

//****  定数宣言        ********************************************

#define PICH  10              //割込み　ms

#define PAGENUM   4           //選択ページ枚数

#define MAXLINE   99          //プログラム行数

#define BLANK     0x20        //空白判定　charコード


/*
//  GY271                     //コンパスセンサー
#define ADR271    0x0D        //GY271アドレス
#define OFFSET_X  184  //479       //コンパスオフセット
#define OFFSET_Y  688  //1142

//  GY9250
#define ADR9250   0x68        //MPU9250アドレス
#define ADR8963   0x0C        //磁気センサのスレーブアドレス
#define SCALEACCX  0.0047886  //加速度換算比率
#define SCALEACCY  0.0047886
#define SCALEACCZ  0.0047886

#define SCALEMAGX  0.177467   //コンパス換算比率
#define SCALEMAGY  0.177467
#define SCALEMAGZ  0.171024

#define OFFSET_X  -5.24       //コンパスオフセット
#define OFFSET_Y  +36.74
#define OFFSET_Z  +27.96
*/


//****  グローバル変数  ************************************

NRob3			nrob;													//初期化
NDspMode	dsmd(nrob);
NDspPrg		dspr(nrob);

//------    プログラム本体変数   ------------------------
byte			prgMem[MAXLINE+1][5];					//プログラムデータ

int				prCnt=0;											//プログラムカウンタ
int				memStack[5];									//スタックメモリ-プログラムカウンタ
byte			memJudg[5];										//判定値スタック
int				cntStack=0;										//スタックポインタ
int				topBlock=0;										//ブロック命令始まる場所
int				prgLast=0;										//ﾌﾟﾛｸﾞﾗﾑ最後

//------    タイマ変数   ------------------------
//int						flg10ms=0;
unsigned long	intTm10;
//unsigned long	intMill;
/*
byte			flg10ms=0;
byte			flg50ms=0;
byte			flg100ms=0;
unsigned long	intTm10;
unsigned long	intTm50;
unsigned long	intMill;
*/
//------    モード切替部変数    ------------------
byte			mode=0;												//モード 0=chg/1=act/2=monitor/3,4=Edit
byte			chgmode=1;

//------    プログラム実行部変数    --------------
//byte		isRemokon=0;									//リモコン使ったプログラムか
byte			isServo=0;										//サーボ命令あるか？
byte			isCompass=0;									//コンパス命令あるか？
//byte			isSonar=0;										//超音波命令あるか？

byte			jdgLvl;												//判定値レベル
byte			jdgWord;											//判定値
byte			prgJdgW;											//プログラムの判定語

int				Tim[10];											//タイマ
int				X[10];												//変数
int				dspL[10];											//動作表示  0-2:LED/3-6:LCD(int)

int				powA=70;											//v001モーターパワー
int				powB=70;

//------    プログラム編集部変数    --------------
int				ds0=0;												//現在表示1行の位置
byte			flgSelect=0;						//選択中のフラグ　0=編集前/1=文字編集/2=行編集

//------    センサーモニタ部変数    --------------
byte			sensorPage=1;									//センサーモニターページ

//------    センサー入力データ部変数    ----------
//int				ad[9];												//AD入力値 + US
//int				adPin[6]={0,1,2,3,6,7};
//int				adCnt=1;

int				angAbs;												//100%換算角度（360°=100）
//int				orgAng;												//スタート時の角度
int				angRel;												//スタート時相対角度　スタート時50

//byte		is9250=0;											//GY9250あり？
//float		mgx, mgy, mgz;								//9軸センサ読込
//float		acx, acy, acz;

//------    通信関係変数    ----------------------
byte			rcvBuf[20];										//シリアル受信バッファ
int				srCnt=-1;											//シリアル受信カウンタ
byte			flgSrcv=0;										//シリアル受信フラグ

//*** 拍手リモコン    					***************************************
#define CLAP_JUDG1	120									//判定１　音圧レベル
#define CLAP_JUDG2	2										//判定２　ピーク上がり回数
#define CLAP_JUDG3	5										//判定３　ピークから連続下降
#define CLAP_JUDG4	80									//判定４　ピークから下降比率

int	clapMode = 0;		
				//判定状況0=以前/1=ピーク前/2=下降確認/3=判定後の待ち/4=誤判定後の待ち
int sndNow;										//今の音圧
//int	sndMax;								//ピーク
//int judgCnt=0;						//判定のカウント
//int smoni=0;						//シリアルモニタ

int	sadcnt=0;
int sadAdd=0;


byte	actMode=0;		//0=stop/1=fword/2=left/3=right
byte	flgClap;
byte	sensMode=0;
int		sensTime=0;


//------    プログラムディバッグ用    ----------------------
/* debug
byte			testB;

void	test_prgSir(int ln)		//テストモニタ
{
Serial.print(ln);
Serial.print(": ");
Serial.print(prgMem[ln][0]);
Serial.print(": ");
Serial.print(prgMem[ln][1]);
Serial.print(": ");
Serial.print(prgMem[ln][2]);
Serial.print(": ");
Serial.print(prgMem[ln][3]);
Serial.print(": ");
Serial.println(prgMem[ln][4]);
}
//-- */

//****  メイン *****************************************************
//------------------------------------------------
void	setup()
{
/* debug
Serial.begin(9600);
//-- */
  
	nrob.init(50);												//ハード初期化 ピッチ50ms
	dsmd.dsp_modeStr(0);									//初期モード選択画面

	init_PrgData();												//プログラムデータ初期化と読込

//	if(digitalRead(12)==LOW)	
	if(digitalRead(12)==HIGH)	
		clapRemo_main();										//特殊モード

}

//------------------------------------------------
void loop()
{
															//---   モード動作 ---
	switch (mode) {
	 case 0:															//モード変更動作
		chg_Mode_main();
		break;
	 case 1:															//action　動作
		do_Action_main();
		break;
	 case 2:															//sensor  センサーモニタ
		do_Setting_main();
		break;
	 case 3:															//prog  プログラムnew
	 case 4:															//prog  プログラム
		edit_Prg_main();
		break;
	}
}
/*
//------------------------------------------------
void	timer_Int(void)										//基準時間カウント タイマ割込の代り
{
	intMill = millis();

	if(intMill>=intTm10){									//10msタイマ

		flg10ms=1;													//10msフラグ
		intTm10 += 10;
	}
	if(intMill>=intTm50){									//50msタイマ

		flg50ms=1;
		intTm50 += 50;
	}
}
//------------------------------------------------
void	timer_getSW(void)									//タイマ動作＋SW入力
{
	timer_Int();													//タイマ動作
    
	if(flg10ms){													//---10ms
		flg10ms=0;
		nrob.chk_SW();											//SWチェック
  }
}
//------------------------------------------------
byte	is_SelSW(void)										//SelSW入力+タイマ動作
{
	byte ans=0;

//	timer_getSW();

	if(nrob.in_SW(0)){										//selSW IN?
		ans=1;
	}
	return ans;
}
*/


//*** 初期化  ***********************************************
//------------------------------------------------
void	init_PrgData(void)								//プログラムデータ初期化
{
	ds0=1;																//表示用初期行

	mode=0;																//モード 0=chg
	chgmode=1;														//  1=act

	if(chk_ROM()){												//データあれば読込
		read_AllROM();
	}else{																//なければ初期化
		init_ROM();
	}
																				//その他動作関係変数初期化
	prCnt = 1;
	for(int i=0; i<10; i++){
		dspL[i]=0;
		Tim[i]=0;
		X[i]=0;
	}
}
//------------------------------------------------

//*** モード変更動作  ***************************************
//------------------------------------------------
void	chg_Mode_main(void)								//モード変更動作メイン
{
	nrob.LCD_noCursor();									//カーソル消す
	nrob.LCD_noBlink();

	chgmode=1;
	dsmd.dsp_modeStr(chgmode);
	while(1){
//		timer_getSW();											//タイマ動作＋SW入力
    nrob.loop();

		if(nrob.in_SW(2)){									//Up
			if(chgmode<PAGENUM) chgmode++;
			else								chgmode=1;
			dsmd.dsp_modeStr(chgmode);
		}
		if(nrob.in_SW(1)){									//Down
			if(chgmode>1) chgmode--;
			else					chgmode=PAGENUM;
			dsmd.dsp_modeStr(chgmode);
    }
		if(nrob.in_SW(0)){									//Sel SW
			mode = chgmode;										//選択ＯＫ
		break;
		}
	}
	dsmd.dsp_modeStr(0);               //Wait表示で戻る
}


//*** 動作  *************************************************
//------------------------------------------------
void	do_Action_main(void)							//プログラム実行動作メイン
{

	prg_Analyse();												//プログラム解析実行切替
	if(isServo){
		nrob.servo_ON();
	}

	nrob.LCD_clear();											//実行画面表示
	nrob.LCD_setCursor(0, 0);
	nrob.LCD_print("Program run");
	dsp_L_All();													//L変数も表示

	prCnt = 1;

	act_Wait(5);												//500ms待ってスタート

	while(1){
		timcnt_Action();									//動作時基本タイマーと動作
/*-- 実行テスト
		if(prCnt>29){
			test_prgSir(prCnt);							//テストモニタ
		}
//debug--*/
																				//プログラム行順実行
		if(prgMem[prCnt][1]!=0){
			if(ctrl_Branch()){								//条件分岐
				do_command();										//コマンド動作
			}else{
				prCnt++;
			}
			if(cntStack==0){									//メインプログラムの最後
				if(prCnt>=topBlock){
					asm volatile ("  jmp 0");			//　リセット
				}
			}
		}else{
/*v036
			if(cntStack>0){										//サブルーチン動作中なら
				do_return();
				prCnt++;
			}else{														//通常ルーチンならトップへ
				//prCnt = 1;
				asm volatile ("  jmp 0"); 			//　エラーリセット
			}
*/
			asm volatile ("  jmp 0"); 			//　エラーリセット//v036
		}
	}

}
//------------------------------------------------
int	timcnt_Action(void)								//動作時基本タイマーと動作
{
	int ans=0;
	float ang;
	static int uno=1;
	static byte flg100ms=0;

	if(nrob.loop()){											//50ms毎動作
/*
		if(isSonar){												//超音波センサあれば読込
			nrob.chk_US(uno);
			if(uno==1)	uno=2;
			else				uno=1;
		}
*/
		if(isCompass){											//コンパスあれば読込
			ang = (float)nrob.get_Angle();		//絶対値
			angAbs = int((ang*100.0)/360.0);	//360->100 換算
			ang = (float)nrob.get_RelAng();		//相対値
			angRel = int((ang*100.0)/360.0);
		}
		if(flg100ms){												//100ms毎タイマカウント
			flg100ms=0;
			Timer_Count();
			ans=1;
		}else{
			flg100ms=1;
		}
	}
	return ans;

}
//------------------------------------------------
void	act_Wait(int c)										//動作ウエイト　c:待ち時間(x100ms)
{
	while(1){
		if(timcnt_Action()){								//動作時基本タイマーと動作
			if(c--<=0)	break;								//100ms
		}
	}
}
//------------------------------------------------
void	prg_Analyse(void)									//プログラム解析
{
	int i=1;
	byte	isSonar=0;
	byte	isCol=0;												//v350
	byte* buf;

	isServo=0;														//サーボ命令あるか
	isCompass=0;													//コンパス使用しているか？
	topBlock=0;

	while(prgMem[i][1]!=0){								//すべての行の

		buf=dspr.chg_PrgDsp(0, i, prgMem[i]);		// プログラム文字変換
/*
Serial.print(buf[0]);//debug
Serial.print("/ ");//debug
Serial.print(buf[1]);//debug
Serial.print("/ ");//debug
Serial.println(buf[2]);//debug
*/
		
		for(int j=0; j<16; j++){								// 1行内の文字を調べる
			switch(buf[j]){
				case 'S':
					if(isSonar<1){
						if(buf[j+1]=='7')	isSonar=1;	//v355
					}else if(isSonar<2){
						if(buf[j+1]=='8')	isSonar=2;
					}
					break;

				case 'C':
					isCompass = 1;
					break;

				case 'V':
					isServo = 1;
					break;

				case 'I':														//v350
					isCol = 1;
					break;
			}
		}
		if(buf[2]=='B'){
			if(topBlock==0)	topBlock=i; //ブロック命令のトップをメモリ
		}

		i++;

	}
	nrob.use_US(isSonar);									//超音波設定をnrobにセット
	if(isCol)	nrob.use_SubIn(1);					//v351
	if(topBlock==0)	topBlock=i;
	prgLast=i;

}

//------------------------------------------------
byte	ctrl_Branch(void)									//条件分岐  ans:1=実行/2=スキップ
{
	byte ans=0;

	jdgLvl = (prgMem[prCnt][0]>>4);				//階層レベル
	prgJdgW = prgMem[prCnt][0]&0x0F;

	if(jdgLvl==0){												//ネストなければ未判定
		jdgWord=0;
		ans=1;

	}else{																//ネストあれば判定値比較

/* test
Serial.print("jdgLvl jdgWord prgJdgW : ");
Serial.print(jdgLvl);
Serial.print("/ ");
Serial.print(jdgWord);
Serial.print("/ ");
Serial.println(prgJdgW);
delay(100);
//--*/

		switch (jdgLvl) {
		 case 1:														//
			jdgWord &= 0x01;
			prgJdgW &= 0x01;
			break;
		 case 2:														//
			jdgWord &= 0x03;
			prgJdgW &= 0x03;
			break;
		 case 3:														//
			jdgWord &= 0x07;
			prgJdgW &= 0x07;
		}
		if(jdgWord==prgJdgW)	ans=1;				//階層ごと比較
	}

	return ans;
}

//------------------------------------------------
void	do_command(void)									//コマンド動作
{
/*--debug
test_prgSir(prCnt);
//---*/
/*
	if(prgMem[prCnt][1]<10)       do_MoveCom();
	else if(prgMem[prCnt][1]<20)  do_IfCom();     //?
	else if(prgMem[prCnt][1]<30)  do_WithinCom(); //$
	else if(prgMem[prCnt][1]<40)  do_SetCom();    //#
	else if(prgMem[prCnt][1]<50)  do_JumpCom();   //JorB
*/

	if(prgMem[prCnt][1]<40){
		if(prgMem[prCnt][1]<10)       do_MoveCom();
/*v036
		else if(prgMem[prCnt][1]<20)  do_IfCom();     //?
		else if(prgMem[prCnt][1]<30)  do_WithinCom(); //$
		else 													do_SetCom();    //#
*/
		prCnt++;																			//次の行

	}else{
//v036		do_JumpCom();   							//JorB
		do_jumpN();													//番号へ直接ジャンプ

	}
}

//------------------------------------------------
void	do_MoveCom(void)									//コマンド 動作系
{
	switch (prgMem[prCnt][1]) {
		case 1:															//^コマンド
			do_Forward();
			break;
		case 2:															//<コマンド
			do_Lrot();
			break;
		case 3:															//>コマンド
			do_Rrot();
			break;
		case 4:															//vコマンド
			do_Back();
			break;
		case 5:															//Vコマンド
			do_Servo();
			break;
		case 6:															//Jコマンド
			do_jumpN();
			break;
	}
/*v036
	switch (prgMem[prCnt][1]) {
		case 1:															//Gコマンド
			do_Go();
			break;
		case 2:															//Mコマンド
			do_Motor();
			break;
		case 3:															//Vコマンド
			do_Servo();
			break;
		case 4:															//Wコマンド
			do_Wait();
			break;
		case 5:															//Lコマンド
			do_LEDLCD();
			break;
		case 6:															//Oコマンド v351
			do_SubOut();
			break;
	}
*/
}
//------------------------------------------------
void	do_Forward(void)									//^コマンド モーター＋wait
{
  int wt = chg_Argument(prgMem[prCnt][2]);

	nrob.act_motorAB(powA,powB);
	act_Wait(wt);
	nrob.act_motorAB(0,0);
}
//------------------------------------------------
void	do_Back(void)											//vコマンド モーター＋wait
{
  int wt = chg_Argument(prgMem[prCnt][2]);
	int pL = -(int)((float)powA*0.8);
	int pR = -(int)((float)powB*0.8);

	nrob.act_motorAB(pL,pR);
	act_Wait(wt);
	nrob.act_motorAB(0,0);
}
//------------------------------------------------
void	do_Lrot(void)											//<コマンド モーター＋wait
{
  int wt = chg_Argument(prgMem[prCnt][2]);
//	int pL = -(int)((float)powA*0.6);
//	int pR = (int)((float)powB*0.6);
	int pL = -(int)((float)powA*0.8);	//v038
	int pR = (int)((float)powB*0.8);

	nrob.act_motorAB(pL,pR);
	act_Wait(wt);
	nrob.act_motorAB(0,0);
}
//------------------------------------------------
void	do_Rrot(void)											//>コマンド モーター＋wait
{
  int wt = chg_Argument(prgMem[prCnt][2]);
	int pL = (int)((float)powA*0.8);
	int pR = -(int)((float)powB*0.8);

	nrob.act_motorAB(pL,pR);
	act_Wait(wt);
	nrob.act_motorAB(0,0);
}
//------------------------------------------------
void	do_Servo(void)										//サーボ
{
  int no,pw;

  no=(int)(prgMem[prCnt][2]);						//配列NO
  if(no>0 && no<3){
    pw = chg_Argument(prgMem[prCnt][3]);

		if(pw==0){
			pw=2;
		}else{
			pw=120;
		}
		no=no-1;

    nrob.act_ServoDir(no, pw);
		act_Wait(10);
/*
    nrob.act_ServoAbs(no, pw);

		while(1){
			if(timcnt_Action()){								//動作時基本タイマーと動作
				if(!nrob.flgServoAct)	break;			// サーボ動作終わり待つ
			}
		}
		//act_Wait(10);
*/
  }
}

/*v036
//------------------------------------------------
void	do_SubOut(void)										//O subOutボードへ書込み v351
{
  int i,j;
  i = prgMem[prCnt][2];               	//配列NO
  if(i<0 || i>9)  return;
  i--;

  j = chg_Argument(prgMem[prCnt][3]); 	//代入値
	j = (j*255)/100;

	nrob.write_SubOut(i,j);
}

//------------------------------------------------
void	do_Go(void)												//Goコマンド モーター＋wait
{
  int a = chg_Argument(prgMem[prCnt][2]);   //数字変換して
  int b = chg_Argument(prgMem[prCnt][3]);
  int c = chg_Argument(prgMem[prCnt][4]);

  nrob.act_motorA((a*255)/100);      		//ドライバ駆動
  nrob.act_motorB((b*255)/100);
	act_Wait(c);
//  delay(c*100);                      		//wait
  nrob.act_motorA(0);               		//停止
  nrob.act_motorB(0);

}

//------------------------------------------------
void	do_Motor(void)										//モーターコマンド
{
  int a = chg_Argument(prgMem[prCnt][2]);   //数字変換して
  int b = chg_Argument(prgMem[prCnt][3]);

  nrob.act_motorA((a*255)/100);      		//ドライバ駆動
  nrob.act_motorB((b*255)/100);
}
//------------------------------------------------
void	do_Servo(void)										//サーボ
{
  int no,pw;

  no=(int)(prgMem[prCnt][2]);						//配列NO
  if(no>0 && no<3){
    pw = chg_Argument(prgMem[prCnt][3]);
  	pw = (pw*9)/5;    //180度換算
  	if(pw<9)   pw=9;
  	if(pw>180) pw=180;
		
    nrob.act_ServoAbs(no, pw);
  }
}
//------------------------------------------------
void	do_Wait(void)											//Waitコマンド
{
  int wt = chg_Argument(prgMem[prCnt][2]);
	act_Wait(wt);
//  delay(wt*100);
}
*/
/*v036
//------------------------------------------------
void	do_IfCom(void)										//? 判定動作
{
  int i,j,dt;
  byte  ans=0;

  if(prgMem[prCnt][2]>9)  return;   		//配列以上は何もしない

  i = prgMem[prCnt][2];                 //配列NO
  j = chg_Argument(prgMem[prCnt][4]);   //比判定値

  if(i<0 || i>9)  return;

	dt = get_Variable(prgMem[prCnt][1]-10,i);	//変数

  switch(prgMem[prCnt][3]){         		//記号に合わせて判定

    case 243:                       		//=
      if(dt==j)     ans = 1 ;
      break;
    case 240:                       		//<
      if(dt<j)      ans = 1 ;
      break;
    case 241:                       		//>
      if(dt>j)      ans = 1 ;
      break;
    case 242:                       		//!
      if(dt!=j)      ans = 1 ;
      break;
  
    default:  return;
  }

  switch(jdgLvl){             					//判定結果を値にセット

    case 0:
      jdgWord=0;
      if(ans) jdgWord |= 0x01;
      break;

    case 1:
      jdgWord &= 0x01;
      if(ans) jdgWord |= 0x02;
      break;

    case 2:
      jdgWord &= 0x03;
      if(ans) jdgWord |= 0x04;
      break;

    case 3:
      jdgWord &= 0x07;
      if(ans) jdgWord |= 0x08;
      break;

    default:  return;             			//4階層以上にはならない
  
  }
  jdgLvl++;

}
//------------------------------------------------
void	do_WithinCom(void)								//$ 範囲判定動作
{
  int i,lo,hi,dt;
  byte  ans=0;

  if(prgMem[prCnt][2]>9)  return;   		//配列以上は何もしない

  i = prgMem[prCnt][2];             		//配列NO
  lo = chg_Argument(prgMem[prCnt][3]);
  hi = chg_Argument(prgMem[prCnt][4]);

  if(i<0 || i>9)  return;

	dt = get_Variable(prgMem[prCnt][1]-20,i);	//変数

  if(dt>lo && dt<hi)  ans = 1;      		//範囲判定

  switch(jdgLvl){             					//判定結果を値にセット

    case 0:
      jdgWord=0;
      if(ans) jdgWord |= 0x01;
      break;

    case 1:
      jdgWord &= 0x01;
      if(ans) jdgWord |= 0x02;
      break;

    case 2:
      jdgWord &= 0x03;
      if(ans) jdgWord |= 0x04;
      break;

    case 3:
      jdgWord &= 0x07;
      if(ans) jdgWord |= 0x08;
      break;

    default:  return;             			//4階層以上にはならない
  
  }
  jdgLvl++;
}
//------------------------------------------------
void	do_SetCom(void)										//# 変数セット命令
{
 int i,j,dt;
  byte  ans=0;
  byte  mask;

  if(prgMem[prCnt][2]>9)  return;				//配列以上は何もしない
  if(prgMem[prCnt][3]<240)  return; 		//記号でない場合も何もしない

  switch(prgMem[prCnt][1]){         		//判定対象をセット

    case 32:  do_SetX();  break;
    case 33:  do_SetTim();  break;
    default:  return;
  }
}
//------------------------------------------------
void	do_SetX(void)											//# 変数セット命令 X
{
  int i,j;
  i = prgMem[prCnt][2];               	//配列NO
  if(i<0 || i>9)  return;
  j = chg_Argument(prgMem[prCnt][4]); 	//代入値

  switch(prgMem[prCnt][3]){     				//記号に合わせて演算
    case 243: X[i] = j;   break;  			// =
    case 244: X[i] += j;  break;  			// +
    case 245: X[i] -= j;  break;  			// -
    case 246: X[i] *= j;  break;  			// *
    case 247: X[i] /= j;  break;  			// /
  }
}
//------------------------------------------------
void	do_SetTim(void)										//# 変数セット命令 T
{
  int i,j;
  i = prgMem[prCnt][2];               	//配列NO
  if(i<0 || i>9)  return;
  j = chg_Argument(prgMem[prCnt][4]); 	//代入値

  switch(prgMem[prCnt][3]){       			//記号に合わせて演算
    case 243: Tim[i] = j;   break;
    case 244: Tim[i] += j;  break;
    case 245: Tim[i] -= j;  break;
    case 246: Tim[i] *= j;  break;
    case 247: Tim[i] /= j;  break;
  }
}
*/
//------------------------------------------------
void	dsp_L_All(void)										//L変数表示
{
  for(int i=0; i<4; i++)
    nrob.dsp_Number2((i*4), 1, dspL[i]);
}
//------------------------------------------------
void	do_jumpN(void)										//番号へ直接ジャンプ
{
  if(prgMem[prCnt][2]>=0){              //プログラムのある行なら
    if(prgMem[prCnt][2]<prgLast){
      prCnt=prgMem[prCnt][2];         //プログラムカウンタ更新
			jdgWord=0;
    }
  }
	if(prCnt<0)	prCnt=0;
}



/*v036
//------------------------------------------------
void	do_LEDLCD(void)										//L LED,LCD操作
{
  int i,j;
  i = prgMem[prCnt][2];               	//配列NO
  if(i<0 || i>9)  return;
  j = chg_Argument(prgMem[prCnt][3]); 	//代入値

  i--;
  dspL[i] = j;

  if(i<3){                          		//表示動作// 123はLED
    if(dspL[i])     nrob.LED_ON(i);
    else            nrob.LED_OFF(i);
  }else if(i<8){                    		// 4-7はLCD
    nrob.dsp_Number2(((i-3)*4), 1, dspL[i]);
  }
}
//------------------------------------------------
void	do_JumpCom(void)									//J 動作
{
  if(prgMem[prCnt][1]==40){
		do_return();												//Block終わりでreturn
		prCnt++;

	}else if(prgMem[prCnt][1]==41){
		do_jumpB();													//Blockジャンプ(サブルーチン)

	}else{
		do_jumpN();													//番号へ直接ジャンプ
	}
}
//------------------------------------------------
void	do_jumpB(void)										//Blockジャンプ(サブルーチンジャンプ)
{
  int newCnt;   												//ジャンプ先の番号

  newCnt=seek_Block(prgMem[prCnt][2]);  //ジャンプ先があれば飛ぶ
  if(newCnt){
    if(cntStack<4){                     //スタックは４段まで
      memJudg[cntStack]=jdgWord;        //スタックメモリ
      memStack[cntStack]=prCnt;
      cntStack++;
			jdgWord=0;
      prCnt=newCnt+1;                   //プログラムカウンタ変更
    }
  }else{
		prCnt++;														//ブロックなければ何もしない
	}
}
//------------------------------------------------
void	do_return(void)										//Block終わりでreturn
{
  if(cntStack==0){          //スタック０ならjikkouエラー
		asm volatile ("  jmp 0");
    prCnt=1;
  }else{
    cntStack--;         
    prCnt=memStack[cntStack];         //スタックメモリ戻す
    jdgWord=memJudg[cntStack];
  }
}

//------------------------------------------------
int		seek_Block(byte no)								//Block を探す
{
  int i=topBlock;   										//プログラムカウンタ

  while(prgMem[i][1]!=0){
    if(prgMem[i][1]==40){     					//'B'を探す
      if(prgMem[i][2]==no){
        return i;               				//該当番号あれば　行番号を返す
      }
    }
    i++;
  }
  return 0;                   					//なければ0を返す
}
//------------------------------------------------
void	do_jumpN(void)										//番号へ直接ジャンプ
{
  if(prgMem[prCnt][2]>=0){              //プログラムのある行なら
    if(prgMem[prCnt][2]<prgLast){
      prCnt=prgMem[prCnt][2];         //プログラムカウンタ更新
			jdgWord=0;
    }
  }
	if(prCnt<0)	prCnt=0;
}
*/

//------------------------------------------------
int		chg_Argument(byte n)							//引数を数字に変換 正負＋変数
{
  int ans;

  if(n<200){                  					//正負値
    if(n<100)   ans = (int)n;
    else        ans = -(int)(n-100);

  }else{
		ans = n - 200;
		ans = get_Variable(ans/10, ans%10);				//変数 v350
  }
  return ans;
}
//------------------------------------------------
int		get_Variable(int m,int n)					//変数変換 v350
{
	int ans;

  switch(m){ 
		case 0:	ans = get_AD(n); break;					//S
    case 1:	ans = angRel;  break;						//C
    case 2:	ans = X[n];  break;							//X
    case 3: ans = Tim[n];  break;						//T
    case 4: ans = get_COLsenser(n);	break;	//I
    default: ans = 0;
  }
	return ans;

}
//------------------------------------------------
int		get_COLsenser(byte n)							//カラーセンサ値変換
{
	int ans;
	if(n==0)	n=9;
	else			n=n-1;

	ans = nrob.get_SubIn(n);							//v351
	ans /= 10;
	if(ans>99)	ans=99;
	return ans;
}
//------------------------------------------------
void	Timer_Count(void)									//タイマーカウント
{
  for(int i=0; i<10; i++){
    Tim[i]++;
    if(Tim[i]>=100) Tim[i]=0;
  }
}

//------------------------------------------------

//*** AD入力    *********************************************
int	get_AD(int an)										//ADを取込 v351 S9 S0
{
	int ans=0;

	if(an<0){															//エラー
		ans=0;

	}else if(an==0){
		ans=random(0,99);										//A0は乱数

	}else if(an<=6){											//A1-A6　アナログ
		ans = nrob.get_AD(an)/10;						//0～1024を0-99に換算
		if(ans>99)  ans=99;									//上限値
		
	}else if(an<=8){											//A7,8 超音波
		ans = nrob.get_US(an-6);
  	if(ans>99)  ans=99;
  	if(ans<1)   ans=99;

	}else if(an==9){											//SW入力
		for(int i=0;i<5 ;i++){								//SW調べる
			if(nrob.in_SW(i)){									//押されていれば番号返す
				ans=i+1; break;
			}
		}
	}else{																//エラー
		ans=0;
	}
	return ans;
}
//------------------------------------------------

//*** プログラム編集  ***************************************
//------------------------------------------------
void	edit_Prg_main(void)								//プログラムエディタメイン
{
	byte	ans;

	ds0=1;																//1行目から表示
	flgSelect=0;													//非選択状態で開始

	if(mode==3){
		clear_AllLine();										//プログラム新規メモリクリア
	}
	dspr.reDraw(ds0, prgMem[ds0]);				//初期表示
	dspr.cursor_Home();

	while(1){

		nrob.loop();
		//------              編集動作
		if(flgSelect){											//選択動作中
			if(flgSelect==2){
				ans = dspr.edit_InsDel();				//行編集
				if(ans){
					if(ans>1){										//挿入削除確定
						if(ans>3)	setPrg_InsLine(ans-3);
						else			setPrg_DelLine(ans-1);
					}
					flgSelect=0;
					dspr.reDraw(ds0, prgMem[ds0]);//表示戻す
					dspr.adjust_curX();
				}
			}else{
				ans=dspr.edit_Chging();					//プログラム更新中
				if(ans){
					if(ans>10){										//コマンドの更新
						ans-=10;
						set_Prg(ans);								//表示prg変換し
						setPrg_Pattern(ds0+ans-1);	//コマンドパターンをセット
					}else{
						if(ans<9){									//その他の更新
							set_Prg(ans);
						}
					}
					flgSelect=0;
					dspr.reDraw(ds0, prgMem[ds0]);	//表示戻す
					dspr.adjust_curX();
				}
			}
		}else{															//選択前　移動動作

			ans=dspr.edit_Moving();						//移動中選択キーで選択動作
			switch(ans){											//表示変更あれば
			 case 1:
				flgSelect=1;										//選択動作へ
				nrob.LCD_blink();								//ブリンク
				break;
			 case 2:
				flgSelect=2;										//挿入削除動作に
				break;
			 case 3:
				if(ds0>1){											//スクロールアップ
					ds0--;
					dspr.reDraw(ds0, prgMem[ds0]);//再表示
					dspr.adjust_curX();
				}
				break;
			 case 4:
				if(ds0<MAXLINE){								//スクロールダウン　最下行まで可
					ds0++;
					dspr.reDraw(ds0, prgMem[ds0]);//再表示
					dspr.adjust_curX();
				}
			}
			if(nrob.in_LongSW(1)){						//v356スクロールspeedup
				ds0+=10;
				if(ds0>MAXLINE)	ds0=MAXLINE-1;
				dspr.reDraw(ds0, prgMem[ds0]);//再表示
				dspr.adjust_curX();
			}
			if(nrob.in_LongSW(2)){						//v356スクロールspeedup
				ds0-=10;
				if(ds0<0)	ds0=0;
				dspr.reDraw(ds0, prgMem[ds0]);//再表示
				dspr.adjust_curX();
			}
    }

		if(nrob.in_LongSW(0)){							//Sel SW 長押し メモリ
			dsmd.dsp_modeStr(0);							//Wait表示
			write_AllROM();										//プログラム保存
			mode = 0;													//トップ画面に
			break;
		}
	}
}
//------------------------------------------------
void	set_Prg(byte ln)									//プログラム更新　表示->memへ
{
	byte* buf=dspr.chg_DspPrg(ln);				//表示データから変換

	prgMem[buf[0]][0]=buf[1];							//プログラムデータへ
	prgMem[buf[0]][1]=buf[2];
	prgMem[buf[0]][2]=buf[3];
	prgMem[buf[0]][3]=buf[4];
	prgMem[buf[0]][4]=buf[5];

}


//*** センサーモニタ   ************************************
//------------------------------------------------
void	do_Setting_main(void)							//センサーモニタ動作メイン
{
  sensorPage=1;

  while(1){

    switch (sensorPage){
      case 1:                     			//AD入力モニタ
        moni_Blance();
        break;
		}
  }

/*v036
  while(1){

    switch (sensorPage){
      case 1:                     			//AD入力モニタ
        moni_AD();      
        break;
      case 2:                    				//超音波センサモニタ
        moni_Sonar();
        break;
      case 3:                     			//コンパスモニタ
        moni_Compas();
        break;
      case 4:                     			//サーボ動作テスト
        moni_Servo();
        break;
      case 5:                     			//シリアル通信
        moni_Serial();
        break;
    }
  }
*/
}
//------------------------------------------------
void	moni_Blance(void)									//バランス調整
{
	dsmd.moni_Balance_set();							//モニタ画面セット

  while(1){

//    timer_getSW();
    nrob.loop();

		dsmd.moni_Balance_loop(&powA,&powB);

    if(nrob.in_SW(0)){           				//selSW IN?
			delay(400);
			nrob.act_motorAB(powA,powB);
			delay(2000);
			nrob.act_motorAB(0,0);
			write_PowAdjust();
    }
  }
}
/*v036
//------------------------------------------------
void	moni_AD(void)											//AD入力モニタ
{
	dsmd.moni_AD_set();										//ベース表示

  while(1){
		nrob.loop();
		dsmd.moni_AD_loop();								//AD読込と表示

//		timer_getSW();											//動作ピッチとSW読込
	  if(nrob.in_SW(0)){           				//selSW IN?
      sensorPage++;
      break;
		}
  }
}
//------------------------------------------------
void	moni_Sonar(void)									//超音波センサモニタ
{
	dsmd.moni_Sonar_set();
	nrob.use_US(2);

  while(1){

//    if(flg50ms){
//      flg50ms=0;
		if(nrob.loop()){

			dsmd.moni_Sonar_loop();						//測定表示
    }

//		timer_getSW();											//動作ピッチとSW読込
	  if(nrob.in_SW(0)){           				//selSW IN?
      sensorPage++;
      break;
		}
  }
	nrob.use_US(2);
}
//------------------------------------------------
void	moni_Compas(void)									//コンパスモニタ
{
	float ang;

	dsmd.moni_Compas_set();

  while(1){

		if(nrob.loop()){

			ang = (float)nrob.get_Angle();		//絶対値
			angAbs = int((ang*100.0)/360.0);	//360->100 換算
			ang = (float)nrob.get_RelAng();		//相対値
			angRel = int((ang*100.0)/360.0);

      nrob.dsp_Number2(10, 0, angAbs);
      nrob.dsp_Number2(10, 1, angRel);
    }

	  if(nrob.in_SW(2)){           				//UpSW In?	v351
			nrob.get_OffsetCompas();					//オフセット得る
		}
	  if(nrob.in_SW(0)){           				//selSW IN?
      sensorPage++;
      break;
		}
  }
}
//------------------------------------------------
void	moni_Servo(void)									//サーボ動作テスト
{
  nrob.servo_ON();
  isServo=1;
	dsmd.moni_Servo_set();								//モニタ画面セット

  while(1){
		nrob.loop();

//    timer_getSW();

		dsmd.moni_Servo_loop();							//キーに合わせて動作表示

    if(nrob.in_SW(0)){           				//selSW IN?
      sensorPage++;
      break;
    }
  }
  nrob.servo_OFF();
  isServo=0;

}
//------------------------------------------------
void	moni_Serial(void)									//シリアル通信
{
  Serial.begin(9600);
  clear_Srcv();

	dsmd.moni_Serial_set();								//初期表示

  while(1){
		nrob.loop();
		if(nrob.in_SW(0)){									//selSW IN?
      sensorPage=1;											//ページ替え
      break;
    }
                 //--- シリアル受信処理  --- 
    rcv_Serial();               				//受信待ち
    if(flgSrcv){
      com_PC();                 				//モード変更中のみPCと通信
      flgSrcv=0;                				// 次の受信可
    }

  }
  Serial.end();
}
*/

//*** シリアル通信            ****************************************
/*v036
//------------------------------------------------
void	rcv_Serial()											//シリアル通信受信
{
	if(Serial.available() > 0){
		byte c = Serial.read();							//一文字受信

		if(srCnt<0){												//受信待ちの時
			if(c=='['){												// スタートのみ受付
				srCnt=0;
			}
		}else{															//受信中はデータメモリ
			if(c==']'){												// 受信完了でフラグセット
				flgSrcv=1;
				srCnt=-1;
			}else{
				rcvBuf[srCnt] = c;							// データセットして次を待つ
				if(++srCnt>18){									// オーバフロー処理
					clear_Srcv();
				}
      }
    }
  }
}

//------------------------------------------------
void  clear_Srcv()											//シリアルバッファ初期化
{
	for(int i=0; i<18; i++) 
		rcvBuf[i]=BLANK;
	srCnt=-1;
}

//------------------------------------------------
void	com_PC()													//PCと通信
{
	int lno;
	byte* buf;

	switch(rcvBuf[0]){	//受信データ一文字目がコマンド

	 case 'a':														//通信確認
		Serial.print("NRob");
		break;

	 case 'r':														//プログラム読込 ->PC
		lno=((int)(rcvBuf[1]-0x30)*10)			// 番号 数字に変換
				+ (int)(rcvBuf[2]-0x30);

		if(lno>0 && lno<MAXLINE){						// 対象行送信
			if(prgMem[lno][1]!=0){						// プログラムあれば返信
				buf=dspr.chg_PrgDsp(0, lno, prgMem[lno]);	// プログラム文字変換

				for(int i=0; i<16; i++)					// 1行送信
					Serial.write(buf[i]);
				Serial.write('\n');
			}else{														//なければ終了記号
				Serial.write(rcvBuf[1]);
				Serial.write(rcvBuf[2]);
				Serial.println("[n]");
			}
		}
		break;

	 case 'w':														//プログラム書換え <-PC
		lno=((int)(rcvBuf[1]-0x30)*10)			// 番号 数字に変換
				+ (int)(rcvBuf[2]-0x30);

		if(lno>0 && lno<MAXLINE){
			dspr.set_prgDsp(0, rcvBuf);				// 表示データに一時メモリ
			set_Prg(0);												// 表示データを変換してプログラムに
		}
		break;

	 case 'e':														//プログラムメモリ
		nrob.LCD_clear();
		write_AllROM();											// ROMへ書き込み
		asm volatile ("  jmp 0");						//　リセット

//		nrob.LCD_setCursor(0, 0);
//		nrob.LCD_print("Waiting PC      ");
		break;
	}
	clear_Srcv();
	delay(10);
}
*/

//***   prgデータ操作    **********************************************
//------------------------------------------------
void	clear_AllLine(void)								//プログラム全行消去
{
	for(int j=0; j<MAXLINE; j++)
		setPrg_clrLine(j,0);								//全データクリア
}
//------------------------------------------------
void	setPrg_clrLine(int y, int x)			//プログラム一行消去
{
	for(int i=x; i<5; i++)
		prgMem[y][i]=0;											// prgクリア
}
//------------------------------------------------
void	setPrg_InsLine(byte l)						//プログラム一行挿入
{
	int nl=ds0+(l-1);											//編集対象行
	int i=setPrg_seekLast();							//プログラム最終行
  
	while(i!=nl){													//最終行から順に一つ送り空き行を作る
		setPrg_cpyLine(i,i-1);
		i--;
	}
	setPrg_clrLine(nl, 0);								//空けた行を初期化
}
//------------------------------------------------
void	setPrg_DelLine(byte l)						//プログラム一行削除
{
	int i=ds0+(l-1);											//編集対象行
  int ll=setPrg_seekLast();							//プログラム最終行
  
	while(i!=ll){													//対象行から順に前に詰める
		setPrg_cpyLine(i,i+1);
		i++;
	}
	setPrg_clrLine(ll, 0);								//最終行をクリア
}
//------------------------------------------------
int		setPrg_seekLast(void)							//プログラム最後の行を返す
{
	int i=1;
	while(i<MAXLINE){
		if(prgMem[i][1]==0){								//コマンド無しならラスト
			break;
		}
		i++;
	}
	return i;
}
//------------------------------------------------
void	setPrg_cpyLine(int a, int b)			//プログラム一行コピー(b->a)
{
	for(int i=0; i<5; i++)
		prgMem[a][i]=prgMem[b][i];					//１行(5byte)コピー
}
//------------------------------------------------
void	setPrg_Pattern(int pl)						//コマンドの基本パターンセット
{
	if(prgMem[pl][1]<10){
		switch (prgMem[pl][1]) {
			case 1:														//^コマンド
				prgMem[pl][2] = 10;							//^:+10
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;
			case 2:														//<コマンド
				prgMem[pl][2] = 10;							//<:10
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;
			case 3:														//>コマンド
				prgMem[pl][2] = 10;							//>;10
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;
			case 4:														//vコマンド
				prgMem[pl][2] = 10;							//v;10
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;
			case 5:														//Vコマンド
				prgMem[pl][2] = 1;							//V1:01
				prgMem[pl][3] = 1;
				prgMem[pl][4] = 0;
				break;
			case 6:														//Jコマンド
				prgMem[pl][2] = 1;							//J:01
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;

		}
	}
}
/*036
void	setPrg_Pattern(int pl)						//コマンドの基本パターンセット
{
	if(prgMem[pl][1]<10){
		switch (prgMem[pl][1]) {
			case 1:														//Gコマンド
				prgMem[pl][2] = 30;							//G+30+30;10
				prgMem[pl][3] = 30;
				prgMem[pl][4] = 10;
				break;
			case 2:														//Mコマンド
				prgMem[pl][2] = 30;							//M+30+30
				prgMem[pl][3] = 30;
				prgMem[pl][4] = 0;
				break;
			case 3:														//Vコマンド
				prgMem[pl][2] = 1;							//V1;50
				prgMem[pl][3] = 50;
				prgMem[pl][4] = 0;
				break;
			case 4:														//Wコマンド
				prgMem[pl][2] = 10;							//W;10
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 0;
				break;
			case 5:														//Lコマンド
				prgMem[pl][2] = 1;							//L1:01
				prgMem[pl][3] = 1;
				prgMem[pl][4] = 0;
				break;
			case 6:														//Oコマンド
				prgMem[pl][2] = 1;							//O1:30
				prgMem[pl][3] = 30;
				prgMem[pl][4] = 0;
				break;

		}
	}else if(prgMem[pl][1]<20){						//?コマンド
				prgMem[pl][1] = 10;							//?S1<+50
				prgMem[pl][2] = 1;
				prgMem[pl][3] = 241;          
				prgMem[pl][4] = 50;

	}else if(prgMem[pl][1]<30){						//$コマンド
				prgMem[pl][1] = 21;							//$C1;00,50
				prgMem[pl][2] = 1;
				prgMem[pl][3] = 0;
				prgMem[pl][4] = 50;

	}else if(prgMem[pl][1]<40){						//#コマンド
				prgMem[pl][1] = 32;							//#X1=+10
				prgMem[pl][2] = 1;
				prgMem[pl][3] = 243;
				prgMem[pl][4] = 10;

	}else if(prgMem[pl][1]<50){						//B,Jコマンド
		if(prgMem[pl][1]==40){
			prgMem[pl][0] = 0;								//B;1
		}else{															//JN:01 v351
			prgMem[pl][1] = 42;								
		}
		prgMem[pl][2] = 1;
		prgMem[pl][3] = 0;
		prgMem[pl][4] = 0;
	}
}
*/

//*** prgデータ操作　EEPROM    ***************************************
//------------------------------------------------
int		chk_ROM(void)											//ROM書き込みあるかチェック
{
	char  w[16];

	for(int i=0; i<7; i++)  w[i] = (char)EEPROM.read(i);
	w[7] = '\0';

	if(w[0]=='D' && w[1]=='A' && w[2]=='T')
		return 1;
	else
		return 0;
}
//------------------------------------------------
void	init_ROM(void)										//ROM＋prg初期化
{
  clear_AllLine();											//全データクリア
  
  EEPROM.write(0, 'D');
  EEPROM.write(1, 'A');
  EEPROM.write(2, 'T');
//  EEPROM.write(3, 'A');
//  EEPROM.write(4, ' ');

  write_AllROM();
}

//------------------------------------------------
void	read_AllROM(void)									//ROM全読み込み
{
  int i,j,adr;

	read_PowAdjust();

  for(j=0; j<MAXLINE; j++){
    for(i=0; i<5; i++){
      adr = j*5 + i + 5;
      prgMem[j][i] = EEPROM.read(adr);
    }
  }
}

//------------------------------------------------
void	write_AllROM(void)								//ROM全　書込み
{
	int i,j,adr;
	int flg=0;

	for(int j=1; j<MAXLINE; j++){					//とび行トリム

		if(flg){
			setPrg_clrLine(j,0);							//とび行以降は空白に
		}else{
			if(prgMem[j][1]==0)	flg=1;				//先頭空白の行は移行はデータはなし
		}
	}

	for(j=0; j<MAXLINE; j++){							//書込み　全行
		for(i=0; i<5; i++){
			adr = j*5 + i + 5;
			EEPROM.write(adr, prgMem[j][i]);
		}
	}
}
//以下v036追加
//------------------------------------------------
void	read_PowAdjust(void)							//調整値読み込み
{
	powA = (int)EEPROM.read(3);
	powB = (int)EEPROM.read(4);
}
//------------------------------------------------
void	write_PowAdjust(void)							//調整値書込み
{
	EEPROM.write(3, (byte)powA);
  EEPROM.write(4, (byte)powB);
}

//*** 拍手リモコン    					***************************************

void	clapRemo_main(void)							//リモコンメイン
{
	int pL = (int)((float)powA*0.6);
	int pR = (int)((float)powB*0.6);
	byte 	flgStart=0;

	nrob.LCD_clear();
	nrob.LCD_print("Remocom Mode");

	while(1){

		ad_Read();

		if(millis()>=intTm10){
			intTm10 += 10;
			ad_Ave();
			chk_Clap();

			if(flgClap){												//拍手検知
				flgClap=0;
				actMode=0;
				if(sensMode==0){									//最初の拍手
					sensMode=1;
					sensTime=100;
				}else{														//二回目以降
					sensMode++;
					sensTime=50;
				}
			}
			nrob.LCD_setCursor(1,1);
			nrob.LCD_write(0x30+sensMode);			//検出状況表示
			if(sensTime){												//検出時間動作
				if(--sensTime==0){								//タイマーオーバーで動作決定
					if(sensMode<=1){
						actMode=0;
						sensMode=0;
					}else{
						actMode=sensMode-1;
						if(actMode>4)	actMode=4;
						flgStart=1;
						sensMode=0;
					}
					clapMode=9;										//判定のリセット
					chk_Clap();
				}
			}
			nrob.LCD_setCursor(4,1);
			nrob.LCD_write(0x30+actMode);				//動作表示

			switch(actMode){										//モーター駆動
				case 0:
					nrob.act_motorAB(0,0);
					break;
				case 1:
					nrob.act_motorAB(powA,powB);
					break;
				case 2:
					nrob.act_motorAB(-pL,pR);
					break;
				case 3:
					nrob.act_motorAB(pL,-pR);
					break;
				case 4:
					nrob.act_motorAB(-pL,-pR);
					break;
			}
			if(flgStart){											//起動開始時は次の測定を少し待つ	
				delay(100);
				flgStart=0;
			}
		}
	}
}
//---------------------------------------------------------
void ad_Read()								//センサー読込　毎回
{
  sadAdd += analogRead(0);
	sadcnt++;
}
//---------------------------------------------------------
void ad_Ave()									//センサー値平均
{
	sndNow = sadAdd/sadcnt;
	sadAdd=0;
	sadcnt=0;
}
//---------------------------------------------------------
void chk_Clap()								//拍手判定
{
	int tst;
	static int	sndPre,sndPre2;						//１回前、２回前の音圧
	static int	sndMax;										//ピーク
	static int	judgCnt=0;								//判定のカウント
	

	switch (clapMode) {
	 case 0:															//判定以前
		if(sndNow>CLAP_JUDG1){
			clapMode = 1;
			judgCnt = 0;
		}
		break;
	 case 1:															//第１　ピーク待ち
		if(sndNow<=sndPre){										//ピーク迎えた
			sndMax=sndPre;
			clapMode=2;
			judgCnt=1;
		}else{																//ピーク前
			judgCnt++;
			if(judgCnt>=CLAP_JUDG2){						//NG
				clapMode=4;
				judgCnt=0;
			}
		}
		break;
	 case 2:															//第２　下降確認
		if(sndNow<=(sndPre)){
			judgCnt++;
			if(judgCnt>=CLAP_JUDG3){					//連続下降クリア
				tst = (long)(sndNow*100)/sndMax;
				if(tst<CLAP_JUDG4){								//OK
					clapMode=3;
					flgClap=1;
				}else{
					clapMode=4;											//NG
				}
				judgCnt=0;
			}
		}else{																//連続下降していない
			if(sndNow<=((sndPre+sndPre2)/2)){		//変動用補正
				judgCnt++;												// 変動補正可
			}else{
				clapMode=4;													//NG
				judgCnt=0;
			}
		}
		break;
	 case 3:															//第３　拍手判定
	 case 4:															//第４　再判定待ち
		judgCnt++;
		if(judgCnt>10){
			clapMode=0;
		}
		break;
	 case 9:															//判定リセット
		clapMode=0;
		judgCnt=0;
		sndMax=0;
		sndPre=0;
		sndPre2=0;
		break;

	}
	sndPre2=sndPre;											//前回更新	
	sndPre=sndNow;

	if(clapMode)	digitalWrite(13, HIGH);	//検出のモニタ
	else					digitalWrite(13, LOW);

}
//---------------------------------------------------------


