/*
	NRob Library
		NRob メニュー・モニタ表示関係のプログラム
*/

#include "NRobDispMode.h"

//****  表示用テーブル   **********************************

//------    メニュー表示上   --------------------
const PROGMEM byte modeStr1[80]={
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbe,0xdd,0xc0,0xb8,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbc,0xdd,0xb7,0x20,0x20,0x20,0x20,0x20,//select
  0x20,0x53,0x45,0x4c,0x45,0x43,0x54,0x20,0xbc,0xad,0xb3,0xbe,0xb2,0x20,0x20,0x20,//select
  };
//------    メニュー表示下   --------------------
const PROGMEM byte modeStr2[80]={
  0x20,0x4d,0x4f,0x44,0x45,0x20,0x20,0xd3,0xb0,0xc4,0xde,0x20,0x20,0x20,0x20,0x20,//モード
  0x20,0x41,0x43,0x54,0x49,0x4f,0x4e,0x20,0xc4,0xde,0xb3,0xbb,0x20,0x20,0x20,0x20,//ドウサ
//  0x20,0x53,0x45,0x4e,0x53,0x4f,0x52,0x20,0xbe,0xdd,0xbb,0xb0,0x20,0x20,0x20,0x20,//センサー
  0x20,0x53,0x65,0x74,0x74,0x69,0x6e,0x67,0x20,0xbe,0xaf,0xc3,0xb2,0x20,0x20,0x20,//セッテイ
  0x20,0x50,0x52,0x4f,0x47,0x52,0x41,0x4d,0xcc,0xdf,0xdb,0xb8,0xde,0xd7,0xd1,0x20,//プログラム
  0x20,0x50,0x52,0x4f,0x47,0x52,0x41,0x4d,0xcc,0xdf,0xdb,0xb8,0xde,0xd7,0xd1,0x20,//プログラム
  };


//---------------------------------------------------------

NDspMode::NDspMode(NRob3& nr):rob(nr)
{
}

//*** メニュー切替　モード表示   ***************************
//---------------------------------------------------------
void	NDspMode::dsp_modeStr(int no)
{
  int tmp=no*16;

  rob.LCD_clear();
  if(no==0){
    rob.LCD_print("WAIT");

  }else{
    for(int i=0; i<15; i++) rob.LCD_write(pgm_read_byte(modeStr1+(tmp+i)));
    rob.LCD_setCursor(0, 1);
    for(int i=0; i<15; i++) rob.LCD_write(pgm_read_byte(modeStr2+(tmp+i)));
  }
  rob.LCD_noCursor();
}

//*** センサーモニタ   *************************************
//------------------------------------------------
void  NDspMode::moni_Balance_set(void)			//バランス調整表示
{
  rob.LCD_clear();                    //モニタ画面表示
  rob.LCD_print("  L      R      ");
  rob.LCD_setCursor(0, 1);
  rob.LCD_print(" 11     11      ");
	flgSet=1;
}
//------------------------------------------------
void  NDspMode::moni_Balance_loop(int*pa, int*pb)
																				//バランス調整動作中表示
{
	if(rob.in_SW(4)){             				//Left
		if((*pa)<255){
			(*pa)++;
		}
	  rob.dsp_Number4(1, 1, *pa);
	}
	if(rob.in_SW(3)){             				//Right
		if((*pb)>0){
			(*pb)--;
		}
	  rob.dsp_Number4(8, 1, *pb);
	}
	if(rob.in_SW(2)){											//Up
		if((*pb)<255){
			(*pb)++;
		}
	  rob.dsp_Number4(8, 1, *pb);
	}
	if(rob.in_SW(1)){ 				            //Down
		if((*pa)>0){
			(*pa)--;
		}
	  rob.dsp_Number4(1, 1, *pa);
	}
	if(flgSet){														//初期
	  rob.dsp_Number4(1, 1, *pa);
	  rob.dsp_Number4(8, 1, *pb);
		flgSet=0;
	}

}

/*v036
//------------------------------------------------
void  NDspMode::moni_AD_set(void)				//ADモニタベース表示
{
  rob.LCD_clear();                    //モニタ画面表示
  rob.LCD_print("S1-- S2-- S3--  ");
  rob.LCD_setCursor(0, 1);
  rob.LCD_print("S4-- S5-- S6--  ");
}
//------------------------------------------------
void  NDspMode::moni_AD_loop(void)			//ADモニタ動作中表示
{
  int sx[6]={2,7,12,2,7,12};
  int sy[6]={0,0,0,1,1,1};

//	if(rob.chk_AD()){										//
  	for(int i=0; i<6; i++){       		//表示
			int a=(rob.get_AD(i+1)/10);
			if(a>99)	a=99;
    	rob.dsp_Number2(sx[i], sy[i], a);
    }
//	}
}
//------------------------------------------------
void  NDspMode::moni_Sonar_set(void)		//超音波センサモニタベース表示
{
  rob.LCD_clear();                    	//モニタ画面表示
  rob.LCD_setCursor(0, 0);
  rob.LCD_print("US S7 --  :");
  rob.LCD_setCursor(0, 1);
  rob.LCD_print("US S8 --  :");
}
//------------------------------------------------
void  NDspMode::moni_Sonar_loop(void)		//超音波センサモニタ動作中表示
{
	int us;

	us=rob.get_US(1);
  if(us>99)  us=99;
  rob.dsp_Number2(6, 0, us);			//表示

	us=rob.get_US(2);
  if(us>99)  us=99;
  rob.dsp_Number2(6, 1, us);
}
//------------------------------------------------
void  NDspMode::moni_Compas_set(void)		//コンパスモニタベース表示
{
  rob.LCD_clear();                    //モニタ画面表示
  rob.LCD_setCursor(0, 0);
  rob.LCD_print("COMPASS a --    ");
  rob.LCD_setCursor(0, 1);
  rob.LCD_print("COMPASS b --    ");
}
//------------------------------------------------
void  NDspMode::moni_Servo_set(void)		//サーボ動作テストベース表示
{
  rob.LCD_clear();                //モニタ画面表示
  rob.LCD_setCursor(0, 0);
  rob.LCD_print("Servo M3  --    ");
  rob.LCD_setCursor(0, 1);
  rob.LCD_print("Servo M4  --    ");

  rob.dsp_Number2(10, 0, rob.get_ServoPos(1));
  rob.dsp_Number2(10, 1, rob.get_ServoPos(2));
}
//------------------------------------------------
void  NDspMode::moni_Servo_loop(void)		//サーボ動作テスト動作中表示
{
	if(rob.in_SW(4)){             				//Left
		rob.act_ServoRel(2, -5);
	  rob.dsp_Number2(10, 1, rob.get_ServoPos(2));
	}
	if(rob.in_SW(3)){             				//Right
		rob.act_ServoRel(2, +5);
	  rob.dsp_Number2(10, 1, rob.get_ServoPos(2));
	}
	if(rob.in_SW(2)){											//Up
		rob.act_ServoRel(1, +5);
	  rob.dsp_Number2(10, 0, rob.get_ServoPos(1));
	}
	if(rob.in_SW(1)){ 				            //Down
		rob.act_ServoRel(1, -5);
	  rob.dsp_Number2(10, 0, rob.get_ServoPos(1));
	}
}
//------------------------------------------------
void  NDspMode::moni_Serial_set(void)		//シリアル通信ベース表示
{
  rob.LCD_clear();											//モニタ画面表示
  rob.LCD_setCursor(0, 0);
  rob.LCD_print("Waiting PC      ");
}
*/
//********************************************************************

