/*
	NRob Library
		NRob プログラム表示関係のプログラム
*/

#include "NRobDispPrg.h"

//---------------------------------------------------------

NDspPrg::NDspPrg(NRob3& nr):rob(nr)
{
}
//------------------------------------------------public
void	NDspPrg::reDraw(byte no,byte prg[])		//プログラム再表示(変換して表示)
{
	byte i;
	
	rob.LCD_clear();
	chg_PrgDsp(0, no-1, prg-5);												//0行目は判定用(表示しない)

	chg_PrgDsp(1, no, prg);														//1,2行は表示用
  for(i=0; i<16; i++) rob.LCD_write(prgDsp[1][i]);
	rob.LCD_setCursor(0,1);
	chg_PrgDsp(2, no+1, prg+5);
  for(i=0; i<16; i++) rob.LCD_write(prgDsp[2][i]);
	
  rob.LCD_noBlink();
  rob.LCD_cursor();

}

//---------------------------------------------------------
//*** 編集動作　カーソル移動時  		********************************************

//------------------------------------------------public
byte	NDspPrg::edit_Moving(void)				//移動動作中
//戻り値：0=変更なし/1=選択モードに/2=挿入削除モードに/3=上へ/4=下にスクロール
{
	byte ans=0;

	if(rob.in_SW(0)){											//Sel SW
		if(is_noEditWord(prgDsp[curY][curX])){		//編集文字でないなら右に
			cursor_MoveRight();
		}else{                      //編集対象なら　文字変更開始
			chgWord = prgDsp[curY][curX];			//変更文字セット
			ans = 1;              						//選択モード
			rob.LCD_blink();									//ブリンク
		}
	}
	if(rob.in_SW(4)){											//Left
		ans=cursor_MoveLeft();								//挿入削除モードへの移行確認
	}
	if(rob.in_SW(3)){											//Right
		cursor_MoveRight();
	}
	if(rob.in_SW(2)){											//Up
		ans=cursor_MoveUp();									//スクロールアップ
	}
	if(rob.in_SW(1)){											//Down
		ans=cursor_MoveDown();								//スクロールダウン
	}
	return ans;
}


//*** 編集動作　変更動作中 		**************************************************
//------------------------------------------------public
byte	NDspPrg::edit_Chging(void)				//変更動作中 戻値:0<>動作終了
											//戻り:1or2=更新行/11or12=コマンドの更新/9=何もせず再表示
{
	byte ans=0;
	byte prWord;

	if(rob.in_SW(0)){											//Sel SW
		prgDsp[curY][curX]=chgWord;						//変更文字セット
		prWord=prgDsp[curY][curX-1];
		cursor_MoveRight();//test
		ans=curY;															//変更する行を返す
		if(is_Command(chgWord)){							//コマンド文字は入力アシスト
			if(chgWord=='B'){
				if(prWord!='J'){
					ans+=10;
				}
			}else{
				ans+=10;													//戻り値更新
			}
		}
  }
	if(rob.in_SW(4)){											//Left
		ans=9;																//何もせず終了
		cursor_MoveLeft();
  }
	if(rob.in_SW(3)){											//right
		ans=9;																//何もせず終了
		cursor_MoveRight();
	}
	if(rob.in_SW(2)){											//Up
		select_Com(+1);
	}
	if(rob.in_SW(1)){											//Down
		select_Com(-1);
	}
	return ans;
}

//------------------------------------------------private
void	NDspPrg::select_Com(int i)				//選択文字書換え　コマンド＋その他
{
	byte  up;															//真上の文字
	int m;
	byte no = get_forwardCom();						//編集部前の命令語の位置を調べる

	if(no>=COMNum){												//コマンドない＝コマンド選択
																				//上の行の文字を参照し次のコマンドを選択
		chgWord=get_nextCom(prgDsp[curY-1][curX], i);

	}else{																//コマンド以降

		if(is_ActCom(prgDsp[curY][no])){		//動作系コマンド
			select_ActComArg(no,i);						//  引数選択　動作系
    }else{
      select_JugComArg(no,i);       //　引数選択　判定系
    }
  }

	rob.LCD_write(chgWord);								//変更文字書換え
	rob.LCD_setCursor(curX,curY-1);
}
//------------------------------------------------private
void	NDspPrg::select_ActComArg(int no, int a)	//引数選択動作系
																								//no=コマンド位置/a=変化量
{
	if(prgDsp[curY][no]=='V'){						//Vコマンド サーボ
		if(no==(curX-1)){										//  サーボno選択
			if(chgWord=='1')	chgWord='2';
			else							chgWord='1';
		}else{
			select_Number(a);									//  それ以外は数字変更
		}
	}else {																//サーボ以外は数字変更
		select_Number(a);
	}
}
//------------------------------------------------private
void	NDspPrg::select_JugComArg(int no, int a)	//引数選択判定系 
																								//no=コマンド位置/a=変化量
{
	if(prgDsp[curY][no]=='B'){						//B ブロック番号指定
		chgWord = get_NextNum_VARI(9,a);		//  操作するのは数字のみ
		return;
  }
	if(prgDsp[curY][no]=='J'){						//J ジャンプ命令
		if((curX-1)==no){											//  JN JB 切替時
			if(chgWord=='B')	chgWord='N';
			else							chgWord='B';
		}else{															//それ以外は数字
			chgWord = get_NextNum_VARI(9,a);	//  操作するのは数字のみ
		}
		return;
	}
	if(prgDsp[curY][no]=='#'){						//# 代入コマンド
		if((curX-1)==no){										//  判定用変数位置
			chgWord = get_NextVARI(1,a);			//  変数　切替 代入用
			return;
		}
		if((curX-3)==no){										//  演算子
			chgWord = get_NextKIGO(1,a);			//   記号切替　演算
		return;
		}
	}
	if(prgDsp[curY][no]=='?'){						//? 判定コマンド
		if((curX-3)==no){										//  演算子
			chgWord = get_NextKIGO(0,a);			//   記号切替　判定
			return;
    }
  }
  if((curX-1)==no){											//判定用変数位置
		chgWord = get_NextVARI(0,a);				//  変数　切替
		return;
	}
																				//その他は数字又は変数
	select_Number(a);
}
//------------------------------------------------private
void	NDspPrg::select_Number(int a)			//数字選択時の動作
{
	if(chgWord=='+'){											//符号は+-切替
		chgWord = '-';
	}else if(chgWord=='-'){ 
		chgWord = '+';
                                        //数字
	}else if(is_Number(prgDsp[curY][curX+1])){	//10の桁(後ろが数字か)
		chgWord = get_NextNum_VARI(15,a);					//  数字＋変数　切替 v350
	}else{
		chgWord = get_NextNum_VARI(9,a);			//数字切替
	}
}

//*** 	カーソル移動  			****************************************************

//------------------------------------------------private
void	NDspPrg::cursor_MoveRight(void)		//カーソル移動右
//右にプログラムあれば右へ、空白なら上の行の階層レベルまで右に
{
  int n = get_dspLen(curY);						//行の文字数

  if(get_forwardCom()>=COMNum){					//コマンド未入力行
    if(curX<n) curX++;									//文字数+1まで
  }else{																//コマンドある行
    if(curX<(n-1))  curX++;							//文字数まで
  }
	setCursor(curX,curY);
}
//------------------------------------------------private
byte	NDspPrg::cursor_MoveLeft(void)		//カーソル移動左
{
	byte ans=0;
  if(curX<=2){                //一番左の時
    ans=2;										// 行編集に移行
		flgInsDel=9;
  }else{
		curX--;
		setCursor(curX,curY);
  }
	return ans;
}
//------------------------------------------------private
byte	NDspPrg::cursor_MoveUp(void)			//カーソル移動上 
{
	byte ans=0;

  if(curY==2){													//カーソル下なら上に移動
    curY=1;
		adjust_curX();
  }else{																//カーソル上ならスクロールup
		ans=3;
	}
	return ans;
}
//------------------------------------------------private
byte	NDspPrg::cursor_MoveDown(void)		//カーソル移動下
{
	byte ans=0;

  if(curY==2){													//カーソル下ならスクロール
		ans=4;
  }else{																//カーソル上なら下に
    curY=2;
		adjust_curX();
	}
	return ans;
}

//------------------------------------------------public
void	NDspPrg::cursor_Home(void)				//カーソルホームへ
{
	curX=2; curY=1;
	rob.LCD_setCursor(curX,curY-1);
}
//------------------------------------------------public
void	NDspPrg::setCursor(byte x,byte y)	//カーソル位置のセット
{
	if(x<2)	curX=2;
	else		curX=x;
	if(y<1)	curY=1;
	else		curY=y;
	rob.LCD_setCursor(curX,curY-1);
}

//------------------------------------------------private
void	NDspPrg::adjust_curX(void)				//カーソルX文字ある部分のみ移動
{
	byte i = get_dspLen(curY);							//行文字数
	if(curX>i)	curX=i;
	setCursor(curX,curY);
}

//*** 挿入削除モード   		******************************************************
//------------------------------------------------public

byte	NDspPrg::edit_InsDel(void)				//行編集動作中 
			//戻値:0=未動作/9=動作終了/10桁:10=削除/20=挿入/1桁:編集中の行(1=上or2=下)
{
	byte	ans=0;

	if(flgInsDel>1){											//初期表示
		flgInsDel=0;
		dsp_InsDel();
	}

	if(rob.in_SW(0)){											//sel SW   
		if(flgInsDel) ans = 4+(curY-1);	//挿入確定
		else          ans = 2+(curY-1);	//削除確定
  }
	if(rob.in_SW(4) || rob.in_SW(3)){			//Left or Right
    ans = 1;															//キャンセル
	}
  if(rob.in_SW(2) || rob.in_SW(1)){			//Up or Down
		if(flgInsDel)	flgInsDel=0;
		else					flgInsDel=1;
    dsp_InsDel();													//挿入削除表示
  }
	return ans;
}

//------------------------------------------------private
void	NDspPrg::dsp_InsDel(void)					//挿入削除表示
{
byte romDel[]=
		{0x20,0x44,0x65,0x6C,0x20,0xBB,0xB8,0xBC,0xDE,0xAE,0x20,0x20,0x20,0x20};
byte romIns[]=
		{0x20,0x49,0x6E,0x73,0x20,0xBF,0xB3,0xC6,0xAD,0xB3,0x20,0x20,0x20,0x20};

	rob.LCD_noCursor();
	rob.LCD_setCursor(2, curY-1);
	if(flgInsDel){
		for(int i=0; i<14; i++) rob.LCD_write(romIns[i]);
  }else{
		for(int i=0; i<14; i++) rob.LCD_write(romDel[i]);
  }
}
//------------------------------------------------



//*** プログラムデータを表示データに変換　プログラム(参照)->prgDsp  ************

//------------------------------------------------public
byte*	NDspPrg::chg_PrgDsp(byte ln,byte no,byte prg[])		//１行変換
													//１行変換：ln:表示行(0-2)/no:prglineNo/prg:prgmem参照
{
	lno=ln;

	for(byte i=2; i<16;  i++)  prgDsp[lno][i]=0x20;

	prgDsp[lno][0]=0x30+(no/10);					//行番号２桁
	prgDsp[lno][1]=0x30+(no%10);

	cno=2;
	if(prg[0])	set_Nest(prg[0]);					//階層表示セット
									              				
  if(prg[1]<10){												//コマンドセット1-10まで
	  switch(prg[1]){
			case 1:                           	//直進コマンド
				prgDsp[lno][cno++]='!';
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);							//第一引数
      	break;

			case 2:															//左コマンド
				prgDsp[lno][cno++]='<';
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);							//第一引数
      	break;

    	case 3:                           	//右コマンド
				prgDsp[lno][cno++]='>';
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);							//第一引数
      	break;

    	case 4:                           	//バックコマンド
				prgDsp[lno][cno++]='v';
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);							//第一引数
      	break;

    	case 5:                           	//Vコマンド
				prgDsp[lno][cno++]='V';
      	set_Num1W(prg[2]);             		//第一引数
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[3]);            	//第二引数
      	break;

    	case 6:                           	//jumpコマンド
				prgDsp[lno][cno++]='J';
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);							//第一引数
      	break;

   		default:                          	//無効コマンド
				prgDsp[lno][cno++]=' ';
		}
	}
/*v036
  if(prg[1]<10){												//コマンドセット1-10まで
	  switch(prg[1]){
			case 1:                           	//Gコマンド
				prgDsp[lno][cno++]='G';
      	set_Num2W(1,prg[2]);							//第一引数
      	set_Num2W(1,prg[3]);							//第二引数
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[4]);							//第三引数
      	break;

			case 2:															//Mコマンド
				prgDsp[lno][cno++]='M';
      	set_Num2W(1,prg[2]);            	//第一引数
      	set_Num2W(1,prg[3]); 							//第二引数
      	break;

    	case 3:                           	//Vコマンド
				prgDsp[lno][cno++]='V';
      	set_Num1W(prg[2]);             		//第一引数
      	prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[3]);            	//第二引数
      	break;

    	case 4:                           	//Wコマンド
				prgDsp[lno][cno++]='W';
				prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[2]);            	//第一引数
      	break;

    	case 5:                           	//Lコマンド
				prgDsp[lno][cno++]='L';
      	set_Num1W(prg[2]);              	//第一引数
				prgDsp[lno][cno++]=':';
      	set_Num2W(0,prg[3]);            	//第二引数
      	break;

    	case 6:                           	//Oコマンド
				prgDsp[lno][cno++]='O';
      	set_Num1W(prg[2]);              	//第一引数
				prgDsp[lno][cno++]=':';
      	set_Num2W(1,prg[3]);            	//第二引数
      	break;

   		default:                          	//無効コマンド
				prgDsp[lno][cno++]=' ';
		}
	}
*/
  else if(prg[1]<20){										//コマンドセット10-19まで=? v350
		prgDsp[lno][cno++]='?';							//10=?S/11=?C/12=?X/13=?T/14=?I
		prgDsp[lno][cno++]=VARI[prg[1]-10];		//変数名セット

  	set_Num1W(prg[2]);										//第１引数
  	set_KIGO(prg[3]);											//第２引数
		set_Num2W(1,prg[4]);									//第３引数
	}
  else if(prg[1]<30){										//コマンドセット20-29まで=$
		prgDsp[lno][cno++]='$';								//20=$S/21=$C/22=$X/23=$T/24=$I
		prgDsp[lno][cno++]=VARI[prg[1]-20];		//変数名セット

  	set_Num1W(prg[2]);										//第１引数
		prgDsp[lno][cno++]=':';
		set_Num2W(0,prg[3]);									//第２引数
		prgDsp[lno][cno++]=',';
		set_Num2W(0,prg[4]);									//第３引数
	}
  else if(prg[1]<40){										//コマンドセット30-39まで=#
		prgDsp[lno][cno++]='#';								//32=#X /33=#T/
		prgDsp[lno][cno++]=VARI[prg[1]-30];		//変数名セット

	  set_Num1W(prg[2]);										//第１引数
  	set_KIGO(prg[3]);											//第２引数
		set_Num2W(1,prg[4]);									//第３引数
	}
  else{																	//コマンドセット40-42まで=BorJ
		if(prg[1]==40){												//40=B /41=JB /42=JN
    	prgDsp[lno][cno++]='B';
  	}else{
    	prgDsp[lno][cno++]='J';
    	if(prg[1]==41)  prgDsp[lno][cno++]='B';
    	else        prgDsp[lno][cno++]='N';
  	}
		prgDsp[lno][cno++]=':';
		set_Num2W(0,prg[2]);									//第一引数
	}
	return prgDsp[lno];
}
//------------------------------------------------public
void  NDspPrg::set_prgDsp(byte ln, byte buf[])	//表示データに直接書き込み
{
	for(int i=0; i<16; i++){
		prgDsp[ln][i]=buf[i+1];
	}
}

//------------------------------------------------private
void  NDspPrg::set_Nest(byte lv)				//階層文字セット
{
  byte i,l,w, mask;

  w=lv&0x0F;									//階層データ
  l=(lv&0xF0)>>4;            	//階層レベル
  mask=0x01;
  
  for(i=0; i<l; i++){           //ビット判定して+-セット
    if(w&mask)	prgDsp[lno][i+2]='+';
    else        prgDsp[lno][i+2]='-';
    mask = mask<<1;
  }
  cno=i+2;
}

//------------------------------------------------private
void  NDspPrg::set_Num2W(byte f,byte n)	//数字文字変換  f=0:符号なし/=1:符号付き
{
  byte h,l;
  
  if(n>=200){                   				//変数の時
    n -= 200;
    h = n/10;                     				//10の桁は変数文字
    l = n%10;                     				//1の桁は変数番号
    if(f) prgDsp[lno][cno++]='+';
    prgDsp[lno][cno++]=VARI[h];						//変数名
    prgDsp[lno][cno++]=l+0x30;						//変数番号

  }else{																//数字の時
  
  	if(f){
    	if(n<100) prgDsp[lno][cno++]='+';		//符号
   	 	else      prgDsp[lno][cno++]='-';
 	 	}
  	if(n>=100)  n-=100;										//マイナスの時
  	h=n/10;																//数字2桁変換
  	l=n%10;
  	prgDsp[lno][cno++]=h+0x30;
  	prgDsp[lno][cno++]=l+0x30;
	}
}
//------------------------------------------------private
void  NDspPrg::set_Num1W(byte n)				//数字文字変換 1文字
{
  byte l=n%10;
  prgDsp[lno][cno++]=l+0x30;						//数字1文字
}
//------------------------------------------------private
void  NDspPrg::set_KIGO(byte n)					//算術記号セット
{
  if(n<240){
    n=8;
  }else{
    n -= 240;
    if(n>7)  n=8;
  }
  prgDsp[lno][cno++]=SKIGO[n];
}
//------------------------------------------------

//*** 表示データをプログラムデータに変換　prgDsp->参照配列に			  ************

//------------------------------------------------public
byte*	NDspPrg::chg_DspPrg(byte ln)			//表示データから変換 ln=行番号1or2
{
	byte	y=ln;
	byte	x=0;
	byte	w=0;
  byte	h=0;
  byte	l=0;
  byte	mask=0x01;
	
	prgBuf[0] = chg_dspNum(0, y, x);				//行番号を得る
	x=2;
  while(1){                   						//ネスト階層を調べる
    w = prgDsp[y][x];
    if(w=='+' || w=='-'){     						//階層なら順にセット
      h++;
      if(w=='+') l |= mask;
      mask = mask<<1;
      x++;
    }else{
      break;
    }
  }
	prgBuf[1] = (h<<4)|(l&0x0F);							//階層データをセット

  switch(prgDsp[y][x]){
    case '!':
      prgBuf[2]=01;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case '<':
      prgBuf[2]=02;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case '>':
      prgBuf[2]=03;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case 'v':
      prgBuf[2]=04;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case 'V':
      prgBuf[2]=05;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(0,y,x+3);
      prgBuf[5]=0;
      break;
    case 'J':
      prgBuf[2]=06;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;

		default:
      prgBuf[2]=0;
      prgBuf[3]=0;
      prgBuf[4]=0;
      prgBuf[5]=0;
  }
/*v036
  switch(prgDsp[y][x]){
    case 'G':
      prgBuf[2]=01;
      prgBuf[3]=chg_dspNum(1,y,x+1);
      prgBuf[4]=chg_dspNum(1,y,x+4);
      prgBuf[5]=chg_dspNum(0,y,x+8);
      break;
    case 'M':
      prgBuf[2]=02;
      prgBuf[3]=chg_dspNum(1,y,x+1);
      prgBuf[4]=chg_dspNum(1,y,x+4);
      prgBuf[5]=0;
      break;
    case 'V':
      prgBuf[2]=03;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(0,y,x+3);
      prgBuf[5]=0;
      break;
    case 'W':
      prgBuf[2]=04;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;
    case 'L':
      prgBuf[2]=05;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(0,y,x+3);
      prgBuf[5]=0;
      break;
    case 'O':														//v351
      prgBuf[2]=06;
      prgBuf[3]=prgDsp[y][x+1]-0x30;				//1文字数字に
      prgBuf[4]=chg_dspNum(1,y,x+3);
      prgBuf[5]=0;
      break;
    case 'B':
      prgBuf[2]=40;
      prgBuf[3]=chg_dspNum(0,y,x+2);
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;

    case '?':																//判定命令
			prgBuf[2]=get_VARIno(prgDsp[y][x+1])+10;		//変数記号番号
      prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
			prgBuf[4]=get_KIGOno(prgDsp[y][x+3]);
  		prgBuf[5]=chg_dspNum(1,y,x+4);
      break;

		case '$':																//中間判定
			prgBuf[2]=get_VARIno(prgDsp[y][x+1])+20;		//変数記号番号
      prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
			prgBuf[4]=chg_dspNum(0,y,x+4);;
  		prgBuf[5]=chg_dspNum(0,y,x+7);
      break;

    case '#':																//代入命令
			if(prgDsp[y][x+1]=='X')		prgBuf[2]=32;			//XとTどちらか
			else											prgBuf[2]=33;
      prgBuf[3]=prgDsp[y][x+2]-0x30;							//変数番号
			prgBuf[4]=get_KIGOno(prgDsp[y][x+3]);
  		prgBuf[5]=chg_dspNum(1,y,x+4);
      break;

    case 'J':																//ジャンプ命令
			if(prgDsp[y][x+1]=='B')		prgBuf[2]=41;			//BとNどちらかv351
			else											prgBuf[2]=42;
			prgBuf[3]=chg_dspNum(0,y,x+3);							//(行)番号
      prgBuf[4]=0;
      prgBuf[5]=0;
      break;

		default:
      prgBuf[2]=0;
      prgBuf[3]=0;
      prgBuf[4]=0;
      prgBuf[5]=0;
  }
*/
	return prgBuf;
}
//------------------------------------------------private
byte	NDspPrg::chg_dspNum(byte f,byte dy,byte dx) //数字文字を変換
                              //f=0:２文字のみ/=1:3文字符号付
{
  byte n=0;

	if(f){																//3文字なら符号確認
		if(prgDsp[dy][dx]=='-')		n=100;
		dx++;
	}
	if(prgDsp[dy][dx]==0x20){
		n=0;
	}else{
		if(is_Number(prgDsp[dy][dx])){ 			//数字データ
			n +=  ((prgDsp[dy][dx]-0x30)*10)+ 		//２桁数字変換
      			(prgDsp[dy][dx+1]-0x30);
		}else{																//変数データ
			n = 200;
			n += (get_VARIno(prgDsp[dy][dx])*10);		//変数記号は10の桁
			n += prgDsp[dy][dx+1]-0x30;								//変数番号は1の桁
		}
	}
  return n;
}

//*** コマンド、記号等[配列]の文字確認と操作								************
//------------------------------------------------private
byte	NDspPrg::get_VARIno(byte w)					//変数番号を得る？
{
	byte n=0;
	
	while(n<6){	//v350
		if(w==VARI[n])	break;
		n++;
	}
	return n;
}
//------------------------------------------------private
byte	NDspPrg::get_NextVARI(int no, int a)	//変数　切替 
																					//no=選択範囲:1=SCXT/0=XTのみ/a=加算数
{
	int i=0;

	i=get_VARIno(chgWord);								//変数番号探して
	i=i+a;																//次を選び

	if(no){																//代入
		if(i<2)   i=3;
		if(i>3)   i=2;
	}else{																//判定
		if(i<0)   i=4;
		if(i>4)   i=0;
	}
	return  VARI[i];
}
//------------------------------------------------private
byte	NDspPrg::get_NextNum_VARI(int m, int i)//数字の切替+変数
{																		// m=選択範囲:9=0-9/13=変数まで範囲/i=加算数
	int no;			//数字の値

	if(chgWord>=0x30 && chgWord<=0x39){		//数字の範囲
		no = (int)(chgWord-0x30);						//
	}else{																//それ以外は
		no = (int)get_VARIno(chgWord)+10 ;	//  SCXTを10～13に
	}

	no = no + i;													//次を選んで

	if(no<0) no=m;												//範囲内で回る
	if(no>m) no=0;

	if(no<10) return((byte)(no+0x30));		//次の文字を返す
	else      return VARI[no-10];
}

//------------------------------------------------private
byte	NDspPrg::get_KIGOno(byte w)        	//算術記号を得る？
{
	byte n=0;
	
	while(n<8){
		if(w==SKIGO[n])	break;
		n++;
	}
	return n+240;
}
//------------------------------------------------private
byte	NDspPrg::get_NextKIGO(int no, int a)//記号切替 no=判定演算/a=加算数
{
	int i=0;

	i=get_KIGOno(chgWord)-240;						//記号番号探して
	i=i+a;																//次を選び

	if(no){																//演算
		if(i<3) i=7;
		if(i>7) i=3;
	}else{																//判定
		if(i<0) i=3;
		if(i>3) i=0;
	}

	return  SKIGO[i];											//次の記号を返す
}



//------------------------------------------------private
byte	NDspPrg::get_ComNo(byte w)       //コマンドの番号を得る w=コマンド文字
{
  byte i;
  for(i=0; i<COMNum; i++){
    if(w==command[i]) break;
  }
  return i;
}
//------------------------------------------------
byte	NDspPrg::get_forwardCom(void)			//編集部前の命令語の種類を調べる
{
	byte  ans=255;

	for(byte i=0; i<curX; i++){
		if(is_Command(prgDsp[curY][i])){
			ans = i;
			break;
		}
	}
	return ans;
}
//------------------------------------------------private
byte	NDspPrg::get_nextCom(byte up, int a)//次のコマンド選択
{																									//up=上の文字/a=加算数/w=文字
  int i=0;
	int no;
																				//選択範囲を算出(上の行の文字参照)
	if(up=='?'|| up=='$') no=0;							//判定の下　+or- 
	else if(up=='+')			no=1;							//+の下　+~Bすべて
	else if(up=='-')			no=2;							//-の下 -~B +を除く
	else									no=3;							//基本　G~B  +-を除く

  i=get_ComNo(chgWord);									//データ探して
  i=i+a;                                //次を選び

	if(i<comSt[no])  i=comEd[no];					//範囲内で回る
	if(i>comEd[no])  i=comSt[no];

	if(curX>2){ 													//行頭以外ではBコマンド使わない
		if(command[i]=='B'){
			i=i+a;
    }
  }
  return(command[i]);
}
//*** プログラム編集 - 文字解析 ******************
//------------------------------------------------private
byte	NDspPrg::is_Command(byte w)				//コマンド文字か	w=コマンド文字
{
  byte  i= get_ComNo(w);

  if(i>1 && i<COMNum) return i;
  else                return 0;
}
//------------------------------------------------private
byte	NDspPrg::is_ActCom(byte w)				//動作系のコマンド文字か w=コマンド文字
{
  byte  i= get_ComNo(w);

  if(i>1 && i<7)   return i;
  else             return 0;
}
//------------------------------------------------private
byte	NDspPrg::is_noEditWord(byte w)		//編集文字でないか？
{
  byte  ans=0;

  if(w==':')  ans=1;
  else if(w==',') ans=1;

  return ans;
}
//------------------------------------------------private
byte	NDspPrg::is_Number(byte w)				//数字文字か？
{
  if(w>=0x30 && w<=0x39)  return 1;
  else                    return 0;
}


//------------------------------------------------
//*** プログラム編集 - 行解析 ******************
//------------------------------------------------private
byte	NDspPrg::get_dspLen(int l)				//l行のプログラム文字数を返す
{
  int i=0;
  while(i<16){
    if(prgDsp[l][i]==0x20)  break;
    i++;
  }
  return i;
}


