/*
	NRob Library
		NRob プログラム表示関係のプログラム
*/

#ifndef NROBDISPPRG_h
#define NROBDISPPRG_h

#include "NRob.h"

#define COMNum  13      //コマンドの数


class NDspPrg
{
  public:
		NDspPrg(NRob3& nr);
		void	init(byte* p);								//初期化

		void	reDraw(byte no,byte prg[]);		//プログラム再表示(変換して表示)
		byte	edit_Moving(void);						//移動動作中 戻値:<>1 動作変更
		byte	edit_Chging(void);						//変更動作中 戻値:0<>動作終了
		byte	edit_InsDel(void);						//行編集動作中 戻値:1=動作終了

		void	cursor_Home(void);						//カーソルホームへ
		void	adjust_curX(void);						//カーソルX文字ある部分のみ移動

		byte*	chg_PrgDsp(byte ln,byte no,byte prg[]);		//１行変換
		byte*	chg_DspPrg(byte ln);					//表示データから変換 ln=行番号0or1

		void	set_prgDsp(byte ln, byte buf[]);	//表示データに直接書き込み

	private:
		NRob3& rob;
    		                    //0   1   2   3   4   5   6   7   8   9   0   1
//		byte command[COMNum+1]={ '+','-','G','M','V','L','O','W','?','$','#','B','J'};
//		byte command[COMNum+1]={ '+','-','^','<','>','v','V','J'};
		byte command[COMNum+1]={ '+','-','!','<','>','J'};//v038

              		 // 0  1  2  3                 コマンドの選択番号
//		byte  comSt[4] = {0, 0, 1, 2};              //コマンド選択範囲
//		byte  comEd[4] = {1,12,12,12};
		byte  comSt[4] = {0, 0, 1, 2};              //コマンド選択範囲
//		byte  comEd[4] = {1,7,7,7};
		byte  comEd[4] = {1,5,5,5};	//v038
		//  =0;判定の下　 +or- 
		//  =1;+の下　+~J すべて
		//  =2;-の下  -~J +を除く
		//  =3;基本　  G~B +-を除く

	                    //0   1   2   3   4   5   6   7   8   9 
		byte  SKIGO[10]=  {'<','>','!','=','+','-','*','/',' ',' '};
		byte  VARI[10]=   {'S','C','X','T','I','O','L','B',' ',' '};//v350

		byte  prgDsp[3][16];          //表示データ
		byte	prgBuf[6];							//プログラム変換用バッファ
		byte	lno;										//表示データ行(0or1)
		byte	cno;										//表示データ桁(0-15)
		int		curX=0;
		int		curY=0;
		byte	flgInsDel=0;									//挿入削除フラグ 0=削除/1=挿入/9=初期
		byte	chgWord;											//変更中の文字

		void	select_Com(int i);						//選択文字書換え　コマンド＋その他
		void	select_ActComArg(int no, int a);	//引数選択動作系
		void	select_JugComArg(int no, int a);	//引数選択判定系 
		void	select_Number(int a);							//数字選択時の動作

		void	cursor_MoveRight(void);				//カーソル移動右
		byte	cursor_MoveLeft(void);				//カーソル移動左
		byte	cursor_MoveUp(void);					//カーソル移動上 
		byte	cursor_MoveDown(void);				//カーソル移動下
		void	setCursor(byte x,byte y);			//カーソル位置のセット

		void	dsp_InsDel(void);							//挿入削除表示 

		void  set_Nest(byte lv);				//階層文字セット
		void  set_Num2W(byte f,byte n);	//数字文字変換  f=0:符号なし/=1:符号付き
		void  set_Num1W(byte n);				//数字文字変換 1文字
		void  set_KIGO(byte n);					//算術記号セット

		byte	chg_dspNum(byte f,byte dy,byte dx); //数字文字を変換

		byte	get_VARIno(byte w);						//変数番号を得る？
		byte	get_NextVARI(int no, int a);		//変数　切替 
		byte	get_NextNum_VARI(int m, int i);	//数字の切替+変数
		byte	get_KIGOno(byte w);						//算術記号を得る？
		byte	get_NextKIGO(int no, int a);		//記号切替 no=判定演算/a=加算数
		byte	get_ComNo(byte w);      			//コマンドの番号を得る w=コマンド文字
		byte	get_forwardCom(void);					//編集部前の命令語の種類を調べる
		byte	get_nextCom(byte up, int a);	//次のコマンド選択
		byte	get_dspLen(int l);						//l行のプログラム文字数を返す

		byte	is_Command(byte w);						//コマンド文字か	w=コマンド文字
		byte	is_ActCom(byte w);						//動作系のコマンド文字か w=コマンド文字
		byte	is_noEditWord(byte w);				//編集文字でないか？
		byte	is_Number(byte w);						//数字文字か？

};

#endif

//プログラム5バイトを参照で受け、表示2行に変換、編集されたデータは参照5バイトデータで返す
//編集操作大半を受ける

/*
*データ構造 prg[5] 中身
  0 階層　正負
    上位4ビット：階層0-4/下位４ビット 各階層の正負(YorN)
  1 コマンド  下表
  2-4 引数  ：　0-99:正整数/100-199：負整数/200-209：S1-9/210-219:C1-9/
              220-229:X1-9/230-239:T1-9/240-249:記号

//コマンド
//01  G motor+wait (LR+wait)例:G+50+50:10"
//02  M moter +00,+00(LR)		例:M+50+50"
//03  V servo no,00					例:V1:50
//04  W wait  00						例:W:10
//05  L LED,LCD no,+00      例:L1:01

//10  ? if S  no,kigo,00		例:?S1>+50
//11  ? if C  
//12  ? if X
//13  ? if T
//14  ? if R  rimocom

//20  $ betwen S  no,lo,hi
//21  $ betwen C  no,lo,hi	例:$C1:00,50
//22  $ betwen X  no,lo,hi
//23  $ betwen T  no,lo,hi

//32  # set X no,kigo,0orX	例:#X1=+10
//33  # set T no,kigo,0orX

//40  B:  blockNo   例:B:01  /mem:0,40,no,0,0
//41  JB: blockNo   例:JB:01 /mem:X,41,no,0,0
//42  JN: lineNo    例:JN:12 /mem:X,42,no,0,0
*/



